This is an abstract task that should be used by all those tasks that require to include or exclude files based on pattern matching.

This is very closely based on the ANT class of the same name.

author | Hans Lellelid <hans@xmpl.org> (Phing)
author | Arnout J. Kuiper <ajkuiper@wxs.nl> (Ant)
author | Stefano Mazzocchi <stefano@apache.org> (Ant)
author | Sam Ruby <rubys@us.ibm.com> (Ant)
author | Jon S. Stevens <jon@clearink.com> (Ant
author | Stefan Bodewig <stefan.bodewig@epost.de> (Ant)
author | Bruce Atherton <bruce@callenish.com> (Ant)
version | $Id: 1e1f6274f400b90c2344c8cdb5d3711030b8f44a $
package | phing.tasks.system
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Create instance; set fileset to new FileSet.

    __construct()

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : void

### Parameters

#### $selector

`\FileSelector`

the new selector to add

## add an "And" selector entry on the selector list

    createAnd() : \AndSelector

### Returns

`\AndSelector`

## add a contains selector entry on the selector list

    createContains() : \ContainsSelector

### Returns

`\ContainsSelector`

## add an extended selector entry on the selector list

    createCustom() : \ExtendSelector

### Returns

`\ExtendSelector`

## add a selector date entry on the selector list

    createDate() : \DateSelector

### Returns

`\DateSelector`

## add a depends selector entry on the selector list

    createDepend() : \DependSelector

### Returns

`\DependSelector`

## add a depth selector entry on the selector list

    createDepth() : \DepthSelector

### Returns

`\DepthSelector`

## add a name entry on the exclude list

    createExclude() : \PatternSetNameEntry

### Returns

`\PatternSetNameEntry`

## add a name entry on the include files list

    createExcludesFile() : \PatternSetNameEntry

### Returns

`\PatternSetNameEntry`

## add a selector filename entry on the selector list

    createFilename() : \FilenameSelector

### Returns

`\FilenameSelector`

## add a name entry on the include list

    createInclude() : \PatternSetNameEntry

### Returns

`\PatternSetNameEntry`

## add a name entry on the include files list

    createIncludesFile() : \PatternSetNameEntry

### Returns

`\PatternSetNameEntry`

## add a majority selector entry on the selector list

    createMajority() : \MajoritySelector

### Returns

`\MajoritySelector`

## add a "None" selector entry on the selector list

    createNone() : \NoneSelector

### Returns

`\NoneSelector`

## add a "Not" selector entry on the selector list

    createNot() : \NotSelector

### Returns

`\NotSelector`

## add an "Or" selector entry on the selector list

    createOr() : void

## add a set of patterns

    createPatternSet() : \PatternSet

### Returns

`\PatternSet`

## add a present selector entry on the selector list

    createPresent() : \PresentSelector

### Returns

`\PresentSelector`

## add a "Select" selector entry on the selector list

    createSelector() : \SelectSelector

### Returns

`\SelectSelector`

## add a selector size entry on the selector list

    createSize() : \SizeSelector

### Returns

`\SizeSelector`

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the set of selectors as an array.

    getSelectors(\Project $p) : array

### Parameters

#### $p

### Returns

`array`FileSelector[] An array of selectors in this container

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

### Returns

`boolean`Whether any selectors are in this container

## Called by the parser to let the task initialize properly.

    init()

Inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

inherited_from | \Task::init()

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Called by the project to let the task do it's work.

    main()

Inherited

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

inherited_from | \Task::main()

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()

## Gives the count of the number of selectors in this container

    selectorCount() : int

### Returns

`int`The number of selectors in this container

## Returns an enumerator for accessing the set of selectors.

    selectorElements() : \an

### Returns

`\an`enumerator that goes through each of the selectors

## Sets case sensitivity of the file system

    setCaseSensitive(boolean $isCaseSensitive) : void

### Parameters

#### $isCaseSensitive

`boolean`

"true"|"on"|"yes" if file system is case sensitive, "false"|"off"|"no" when not.

## Sets whether default exclusions should be used or not.

    setDefaultexcludes(boolean $useDefaultExcludes)

### Parameters

#### $useDefaultExcludes

`boolean`

"true"|"on"|"yes" when default exclusions should be used, "false"|"off"|"no" when they shouldn't be used.

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Sets the set of exclude patterns.

    setExcludes(string $excludes)

Patterns may be separated by a comma or a space.

### Parameters

#### $excludes

`string`

the string containing the exclude patterns

## Sets the name of the file containing the includes patterns.

    setExcludesfile(\PhingFile $excludesfile) : void

### Parameters

#### $excludesfile

`\PhingFile`

A string containing the filename to fetch the include patterns from.

## Sets whether or not symbolic links should be followed.

    setFollowSymlinks(boolean $followSymlinks) : void

### Parameters

#### $followSymlinks

`boolean`

whether or not symbolic links should be followed

## Sets the set of include patterns.

    setIncludes(string $includes) : void

Patterns may be separated by a comma or a space.

### Parameters

#### $includes

`string`

the string containing the include patterns

## Sets the name of the file containing the includes patterns.

    setIncludesfile(\PhingFile $includesfile) : void

### Parameters

#### $includesfile

`\PhingFile`

A string containing the filename to fetch the include patterns from.

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## References the project to the current component.

    setProject(\Project $project)

see | \global\ProjectComponent::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Returns the directory scanner needed to access the files to process.

    getDirectoryScanner(\PhingFile $baseDir) : \DirectoryScanner

### Parameters

#### $baseDir

### Returns

`\DirectoryScanner`

## Accessor for the implict fileset.

    getImplicitFileSet() : \FileSet

### Returns

`\FileSet`

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()

### Parameters

#### $slotName

`string`

### Properties

##

    $description : string

Inherited

inherited_from | \Task::$$description

##

    $fileset : \FileSet

##

    $location : \Location

Inherited

inherited_from | \Task::$$location

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project

##

    $target : \Target

Inherited

inherited_from | \Task::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType

##

    $useDefaultExcludes : boolean

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper